///File : common.cpp
//------------------------------------------------------------------------------
/*
    This file is part of Debtest.

    Debtest is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Debtest is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Debtest.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include <iostream>
#include <vector>
#include <fstream>

#include <stdio.h>
#include <stdlib.h>

#include <pthread.h>
//------------------------------------------------------------------------------
#include "common.hpp"
//------------------------------------------------------------------------------
using namespace std;
//------------------------------------------------------------------------------
void *progressFn(void *data)
{
    progressStr &progress = static_cast<progressStr&>(*static_cast<progressStr*>(data));

    while(1)
    {
        // On efface...
        cout << "\r                                             \r" << flush;

        pthread_mutex_lock(&progress.mutex);
        cout << progress.msg;
        if(progress.perCent != 0)
        {
            cout << " " << int(progress.perCent) << "%";
        }
        cout << flush;
        pthread_mutex_unlock(&progress.mutex);

        usleep(200000);
    }

    return NULL;
}
//------------------------------------------------------------------------------
void editProgress(const float &perCent, progressStr &progress)
{
    pthread_mutex_lock(&progress.mutex);
    progress.perCent = perCent;
    pthread_mutex_unlock(&progress.mutex);
}
//------------------------------------------------------------------------------
void editProgressMsg(const string &msg, progressStr &progress)
{
    pthread_mutex_lock(&progress.mutex);
    progress.msg = msg;
    progress.perCent = 0;
    pthread_mutex_unlock(&progress.mutex);
}
//------------------------------------------------------------------------------
int getLine(string &str, FILE *file)
{
    str = "";
    char letter = '\0';

    while(1)
    {
        letter = fgetc(file);

        if(letter == '\n')
        {
            return 1;
        }
        else if(letter == EOF)
        {
            return 0;
        }
        else
        {
            str += letter;
        }
    }
}

//------------------------------------------------------------------------------
vector<string> getPkgList()
{
    const string badStaus = "deinstall";

    vector<string> pkgTbl;

    FILE *pipe = popen("dpkg --get-selections", "r");

    if(pipe)
    {
        string tmp;

        while(getLine(tmp, pipe))
        {
            // Il ne reste que les fichiers de configuration ?
            if(tmp.substr(tmp.size() - badStaus.size()) == badStaus)
            {
                continue;
            }

            // On ne garde que le nom du paquet...
            size_t tabPos = tmp.find('\t');
            if(tabPos != string::npos)
            {
                pkgTbl.push_back(tmp.substr(0, tabPos));
            }
        }

        pclose(pipe);
    }

    return pkgTbl;
}
//------------------------------------------------------------------------------
